<?

if (function_exists("set_time_limit")==1 and get_cfg_var("safe_mode")==0) {
  set_time_limit(1200);
}

require("global.php");

function getuserinfo($userid) {
  global $ubbmembersdir;
  $userinfos=file("$ubbmembersdir/$userid.cgi");

  $userinfo[username]=trim($userinfos[0]);
  $userinfo[password]=trim($userinfos[1]);
  $userinfo[email]=trim($userinfos[2]);
  $userinfo[url]=trim($userinfos[3]);
  $userinfo[permissions]=trim($userinfos[4]);
  $userinfo[job]=trim($userinfos[5]);
  $userinfo[country]=trim($userinfos[6]);
  $userinfo[posts]=intval(trim($userinfos[7]));
  $userinfo[status]=trim($userinfos[8]);
  $userinfo[interests]=trim($userinfos[9]);
  $userinfo[datejoined]=trim($userinfos[10]);
  $userinfo[showemail]=trim($userinfos[11]);
  $userinfo[signature]=trim($userinfos[12]);
  $userinfo[icq]=trim($userinfos[13]);
  $userinfo[allowmail]=trim($userinfos[14]);
  return $userinfo;

}

function getforuminfo($forumid) {
  global $ubbvarspath;

  $forums=file("$ubbvarspath/forums.cgi");

  while(list($key,$val)=each($forums)) {

    $forum=explode("|",$val);

    if ($forum[8]==$forumid) {
      $foruminfo[category]=$forum[0];
      $foruminfo[title]=$forum[1];
      $foruminfo[description]=$forum[2];
      $foruminfo[active]=$forum[3];
      $foruminfo[forumid]=$forum[8];

      break;
    }

  }

  return $foruminfo;
}

function html2bb($htmlcode) {
  global $ubbnoncgiurl;

  // do smilies
  $htmlcode=str_replace("<IMG SRC=\"$ubbnoncgiurl/smile.gif\">",":)",$htmlcode);
  $htmlcode=str_replace("<IMG SRC=\"$ubbnoncgiurl/frown.gif\">",":(",$htmlcode);
  $htmlcode=str_replace("<IMG SRC=\"$ubbnoncgiurl/redface.gif\">",":o",$htmlcode);
  $htmlcode=str_replace("<IMG SRC=\"$ubbnoncgiurl/biggrin.gif\">",":D",$htmlcode);
  $htmlcode=str_replace("<IMG SRC=\"$ubbnoncgiurl/wink.gif\">",";)",$htmlcode);
  $htmlcode=str_replace("<IMG SRC=\"$ubbnoncgiurl/tongue.gif\">",":p",$htmlcode);
  $htmlcode=str_replace("<IMG SRC=\"$ubbnoncgiurl/cool.gif\">",":cool:",$htmlcode);
  $htmlcode=str_replace("<IMG SRC=\"$ubbnoncgiurl/rolleyes.gif\">",":rolleyes:",$htmlcode);
  $htmlcode=str_replace("<IMG SRC=\"$ubbnoncgiurl/mad.gif\">",":mad:",$htmlcode);
  $htmlcode=str_replace("<IMG SRC=\"$ubbnoncgiurl/eek.gif\">",":eek:",$htmlcode);
  $htmlcode=str_replace("<IMG SRC=\"$ubbnoncgiurl/confused.gif\">",":confused:",$htmlcode);

  // bold and italics: easy peasy
  $htmlcode=str_replace("<b>","[b]",$htmlcode);
  $htmlcode=str_replace("</b>","[/b]",$htmlcode);
  $htmlcode=str_replace("<i>","[i]",$htmlcode);
  $htmlcode=str_replace("</i>","[/i]",$htmlcode);
  $htmlcode=str_replace("<B>","[b]",$htmlcode);
  $htmlcode=str_replace("</B>","[/b]",$htmlcode);
  $htmlcode=str_replace("<I>","[i]",$htmlcode);
  $htmlcode=str_replace("</I>","[/i]",$htmlcode);

  $htmlcode=eregi_replace("<a href=\"mailto:([^\"]*)\">([^<]*)</a>","[email]\\2[/email]",$htmlcode);
  $htmlcode=eregi_replace("<a href=\"([^\"]*)\" target=_blank>([^<]*)</a>","[url=\"\\1\"]\\2[/url]",$htmlcode);

  $htmlcode=eregi_replace("<img src=\"([^\"]*)\">","[img]\\1[/img]",$htmlcode);

  // do code tags
  $htmlcode=str_replace("<BLOCKQUOTE><font size=\"1\" face=\"arial,helvetica\">code:</font><HR><pre>","[code]",$htmlcode);
  $htmlcode=str_replace("</pre><HR></BLOCKQUOTE>","[/code]",$htmlcode);

  // do quotes
  $htmlcode=str_replace("<BLOCKQUOTE><font size=\"1\" face=\"arial,helvetica\">quote:</font><HR>","[quote]",$htmlcode);
  $htmlcode=str_replace("<hr></BLOCKQUOTE>","[/quote]",$htmlcode);

  // do lists
  $htmlcode=str_replace("<ul type=square>","[list]",$htmlcode);
  $htmlcode=str_replace("</ul>","[/list]",$htmlcode);
  $htmlcode=str_replace("<ol type=1>","[list=1]",$htmlcode);
  $htmlcode=str_replace("<ol type=A>","[list=a]",$htmlcode);
  $htmlcode=str_replace("</ol>","[/list=a]",$htmlcode);
  $htmlcode=str_replace("<li>","[*]",$htmlcode);

  $htmlcode=str_replace("<p>","\n\n",$htmlcode);
  $htmlcode=str_replace("<P>","\n\n",$htmlcode);
  $htmlcode=str_replace("<br>","\n",$htmlcode);
  $htmlcode=str_replace("<BR>","\n",$htmlcode);

  return $htmlcode;
}

function wordsonly ($text) {

  $text=strtolower($text);

  $text=ereg_replace("<pre>[^<]*</pre>"," ",$text);
  $text=ereg_replace("<[^>]*>"," ",$text); // remove HTML <> tags
  $text=ereg_replace("&[^;];"," ",$text); // remove HTML special chars
//  $text=ereg_replace("[^ 0-9a-z]"," ",$text); // keep only letters and numbers

  $counter=0;

  $words=explode(" ",$text);
  while (list($key,$val)=each($words)) {
    if ($val!="the" and $val!="this" and $val!="and" and $val!="but" and $val!="was" and $val!="that" and $val!="with" and $val!="its" and $val!="you" and $val!="they" and $val!="what" and $val!="why" and $val!="for" and $val!="are" and $val!="our" and $val!="then" and $val!="there" and $val!="which") {
      $counter++;
      $wordarray[$val]=1;
    }
  }

  if ($counter>0) {
    while (list($key,$val)=each($wordarray)) {
      $newwords[]=$key;
    }

    $newwords=implode($newwords," ");
  } else {
    $newwords="";
  }

  return $newwords;
}

function indexthread($threadid) {
  global $DB_site;

  $thread=$DB_site->query_first("SELECT threadid,title FROM thread WHERE threadid=$threadid");

  $subject=$thread[title];

  $posts=$DB_site->query("SELECT userid,username,pagetext FROM post WHERE threadid=$thread[threadid] AND visible=1");
  while ($post=$DB_site->fetch_array($posts)) {
    if ($post[userid]!=0) {
      if ($getuser=$DB_site->query_first("SELECT username FROM user WHERE userid=$post[userid]")) {
        $usernames.=" $getuser[username] ";
      }
    } else {
      $usernames.=" $post[username] ";
    }
    $pagetext.=" $post[pagetext] ";
  }

  $subject=wordsonly($subject);
  $pagetext=$subject." ".wordsonly($pagetext);
  $usernames=wordsonly($usernames);

  $DB_site->query("UPDATE thread SET subjectindex=' ".addslashes($subject)." ',threadindex=' ".addslashes($pagetext)." ',userindex=' ".addslashes($usernames)." ' WHERE threadid=$threadid");

  return 1;
}

?>

<html><head>
<STYLE type=text/css>
BODY {
  font-family: arial;
  font-size: 10pt;
  font-variant: normal;
  font-style: normal;
}
P {
  font-family: arial;
  font-size: 10pt;
  font-variant: normal;
  font-style: normal;
}
</STYLE>
</head>
<body>

<?

if ($step=="") {

?><p>UBB posts, members and forums importer.</p>
<p>Use this script to import setting from the UBB. This will not import any style settings whatsoever - you must manually update these. It will also not import moderators due to significant differences in how moderators work in vBulletin. It will import posts, forums and users though.</p>
<p>Please complete the form below. If you do not know a path, you can find it in the general settings area of the UBB control panel.</p>
<?

  echo doformheader("import","");
  echo makehiddencode("step","2");

  echo "<table border=0>";

  echo makeinputcode("UBB Settings directory: directory that contains UltBB.setup and forums.cgi","ubbsettingsdir");
  echo makeinputcode("UBB Members directory","ubbmembersdir");
  echo makeinputcode("UBB Non-CGI directory","ubbnoncgidir");
  echo makeinputcode("UBB Non-CGI URL","ubbnoncgiurl","http://");

  echo doformfooter();

}

if ($step==2) {

  if ($ubbsettingsdir=="" or $ubbmembersdir=="" or $ubbnoncgidir=="" or $ubbnoncgiurl=="" or $ubbnoncgiurl=="http://") {
    echo "<p>Please complete all the fields</p>";
    exit;
  }

  $ubbsettingsdir=urlencode($ubbsettingsdir);
  $ubbmembersdir=urlencode($ubbmembersdir);
  $ubbnoncgidir=urlencode($ubbnoncgidir);
  $ubbnoncgiurl=urlencode($ubbnoncgiurl);

  echo "<p>From here you can choose what to do. You must do things in this order though: members, forums then posts.</p>";

  echo "<p>1) <a href=\"import.php?step=3&ubbmembersdir=$ubbmembersdir&ubbsettingsdir=$ubbsettingsdir&ubbnoncgidir=$ubbnoncgidir&ubbnoncgiurl=$ubbnoncgiurl\">Import Members</a></p>";

  echo "<p>2) <a href=\"import.php?step=4&ubbmembersdir=$ubbmembersdir&ubbsettingsdir=$ubbsettingsdir&ubbnoncgidir=$ubbnoncgidir&ubbnoncgiurl=$ubbnoncgiurl\">Import Forums</a></p>";

  echo "<p>3) <a href=\"import.php?step=5&ubbmembersdir=$ubbmembersdir&ubbsettingsdir=$ubbsettingsdir&ubbnoncgidir=$ubbnoncgidir&ubbnoncgiurl=$ubbnoncgiurl\">Import Posts</a></p>";

  echo "<p>4) <a href=\"import.php?step=8&ubbmembersdir=$ubbmembersdir&ubbsettingsdir=$ubbsettingsdir&ubbnoncgidir=$ubbnoncgidir&ubbnoncgiurl=$ubbnoncgiurl\">Import Archives and Posts</a></p>";

  // other options

}

if ($step==3) {

  if ($wipe=="") {

    echo doformheader("import","");
    echo makehiddencode("step","3");
    echo makehiddencode("ubbmembersdir",$ubbmembersdir);
    echo makehiddencode("ubbnoncgidir",$ubbnoncgidir);
    echo makehiddencode("ubbnoncgiurl",$ubbnoncgiurl);
    echo makehiddencode("ubbsettingsdir",$ubbsettingsdir);
    echo makehiddencode("startat","0");
    echo "<table border=0>";
    echo makeinputcode("Cycle rate","perpage","1000");
    echo "</table>";

    echo "<p>Do you want to delete all existing members from the vBulletin database before importing new members?</p>";
    echo "<p><input type=submit name=wipe value=yes> <input type=submit name=wipe value=no></p>";

    exit;
  }

  $ubbmembersdir=urldecode($ubbmembersdir);

  if ($wipe=="yes") {
    $DB_site->query("DELETE FROM user WHERE usergroupid<>6");
  }

  $users=file("$ubbmembersdir/memberslist.cgi");

  echo "<p>Importing members...</p>";
  echo "<p>Instructions will appear at the bottom of this page telling what to do when this is done</p>";
  flush();

  $counter=0;

  while (list($key,$val)=each($users)) {

    $counter++;
    if ($counter>=$startat and $counter<$startat+$perpage) {
      $doneimport=1;
      $parts=explode("|!!|",$val);

      $username=trim($parts[0]);
      $userfileid=trim($parts[1]);

      $userinfo=getuserinfo($userfileid);

      $showemail=iif($userinfo[showemail]=="yes",1,0);
      $allowmail=iif($userinfo[allowmail]=="yes",1,0);

      if (strpos($userinfo[permissions],"Admin")==0) {
        $usergroupid=2;
      } else {
        $usergroupid=6;
      }
      if (strpos($userinfo[permissions],"COPPA")==0) {
        $coppauser=0;
      } else {
        $coppauser=1;
      }

      $biography="";
      if (trim($userinfo[job])!="") {
        $biography.="Occupation: ".trim($userinfo[job])."\n";
      }
      if (trim($userinfo[country])!="") {
        $biography.="Location: ".trim($userinfo[country])."\n";
      }
      if (trim($userinfo[interests])!="") {
        $biography.="Interests: ".trim($userinfo[interests])."\n";
      }

      if ( ereg( "([0-9]{1,2})-([0-9]{1,2})-([0-9]{2,4})", $userinfo[datejoined], $regs ) ) {
        $datejoined=mktime(0,0,0,$regs[1],$regs[2],$regs[3])-($timeoffset)*3600;
      } else {
        $datejoined=time();
      }

      $signature=html2bb($userinfo[signature]);

      $usergroup=$DB_site->query_first("SELECT usertitle FROM usergroup WHERE usergroupid=$usergroupid");
      if ($usergroup[usertitle]=="") {
        $gettitle=$DB_site->query_first("SELECT title FROM usertitle WHERE minposts<=$userinfo[posts] ORDER BY minposts DESC LIMIT 1");
        $usertitle=$gettitle[title];
      } else {
        $usertitle=$usergroup[usertitle];
      }

      $DB_site->query("INSERT INTO user (userid,usergroupid,username,password,email,parentemail,coppauser,homepage,icq,aim,yahoo,biography,signature,adminemail,showemail,invisible,usertitle,customtitle,joindate,canpost,cookieuser,daysprune,lastvisit,lastactivity,lastpost,posts,timezoneoffset,emailnotification) VALUES (NULL,$usergroupid,'".addslashes($username)."','".addslashes($userinfo[password])."','".addslashes($userinfo[email])."','',$coppauser,'".addslashes($userinfo[url])."','".addslashes($userinfo[icq])."','','','".addslashes($biography)."','".addslashes($signature)."',$allowmail,$showemail,NOT $showemail,'".addslashes($usertitle)."',0,$datejoined,1,1,-1,".time().",".time().",".time().",$userinfo[posts],0,1)");
      $userid=$DB_site->insert_id();

      if ($userid%100==0) {
        echo "<p>Doing user $userid</p>";
        flush();
      }
    }
  }

  if ($doneimport==1) {
    $startat+=$perpage;

    echo "<script language=\"javascript\">window.location=\"import.php?step=3&startat=$startat&wipe=no&perpage=$perpage&ubbmembersdir=$ubbmembersdir&ubbsettingsdir=$ubbsettingsdir&ubbnoncgidir=$ubbnoncgidir&ubbnoncgiurl=$ubbnoncgiurl\";</script>";
    echo "<p><a href=\"import.php?step=3&startat=$startat&wipe=no&perpage=$perpage&ubbmembersdir=$ubbmembersdir&ubbsettingsdir=$ubbsettingsdir&ubbnoncgidir=$ubbnoncgidir&ubbnoncgiurl=$ubbnoncgiurl\">Click here to continue importing users</a></p>";
  } else {
    echo "<p><b>Completed importing users.</p>";
    echo "<p>Click <a href=\"import.php?step=4&ubbsettingsdir=$ubbsettingsdir&ubbnoncgidir=$ubbnoncgidir&ubbnoncgiurl=$ubbnoncgiurl\">here</a> to import forums.</b></p>";
  }
}

if ($step==4) {

  if ($wipe=="") {
    echo "<p>Do you want to delete all existing forums from vBulletin before importing new forums?</p>";
    echo "<p><a href=\"import.php?step=4&wipe=yes&ubbsettingsdir=$ubbsettingsdir&ubbnoncgidir=$ubbnoncgidir&ubbnoncgiurl=$ubbnoncgiurl\">Yes - remove all existing forums!</a> (Recommended)</p>";
    echo "<p><a href=\"import.php?step=4&wipe=no&ubbsettingsdir=$ubbsettingsdir&ubbnoncgidir=$ubbnoncgidir&ubbnoncgiurl=$ubbnoncgiurl\">No - do not remove existing forums!</a></p>";
    exit;
  }

  $ubbsettingsdir=urldecode($ubbsettingsdir);
  $ubbnoncgidir=urldecode($ubbnoncgidir);

  if ($wipe=="yes") {
    $DB_site->query("DELETE FROM forum");
    $DB_site->query("DELETE FROM category");
  }

  // get categories first:
  $categories=file("$ubbnoncgidir/categories.file");

  echo "<p>Instructions will appear at the bottom of this page telling what to do when this is done</p>";
  echo "<p>Adding categories</p>";

  while (list($key,$val)=each($categories)) {

    if ($val!="") {
      $parts=explode("|||",$val);

      $displayorder=intval($parts[0]);
      $title=$parts[1];
      $categoryid=intval($parts[2]);

      if ($checkcategory=$DB_site->query_first("SELECT categoryid FROM category WHERE categoryid=$categoryid")) {
        $categoryid="NULL";
      }

      echo "<p>Adding category $title</p>";
      flush();

      $DB_site->query("INSERT INTO category (categoryid,title,displayorder) VALUES ($categoryid,'".addslashes($title)."',$displayorder)");

    }
  }

  if (!$checkcat=$DB_site->query_first("SELECT categoryid FROM category")) {
    $DB_site->query("INSERT INTO category (categoryid,title,displayorder) VALUES (1,'Main',1)");
  }

  echo "<p>Categories added successfully</p>";

  echo "<p>Getting Moderators</p>";

  if (file_exists("$ubbsettingsdir/mods.file")==1) {
    $mods=file("$ubbsettingsdir/mods.file");

    while(list($key,$val)=each($mods)) {
      if ($val!="" and strpos($val,"Moderator")>0) {

        eval($val);

      }
    }

  }

  $forums=file("$ubbsettingsdir/forums.cgi");

  echo "<p>Importing forums</p>";
  while (list($key,$val)=each($forums)) {

    if ($val!="") {
      $parts=explode("|",$val);

      $categoryid=intval($parts[0]);
      if ($categoryid==0) {
        $categoryid=1;
      }

      $title=$parts[1];
      $description=$parts[2];
      $canview=iif(trim($parts[3])=="On",1,0);
      $htmlon=iif(trim($parts[4])=="is",1,0);
      $bbcodeon=iif(trim($parts[5])=="is",1,0);
      $bbimgon=iif(trim($parts[10])=="ON",1,0);
      $displayorder=intval($parts[14]);
      $forumid=intval($parts[8]);
      $newpostemail=iif(trim($parts[11])=="yes",1,0);

      echo "<p>Importing forum settings for $title</p>";
      flush();

      if ($checkforum=$DB_site->query_first("SELECT forumid FROM forum WHERE forumid=$forumid")) {
        $forumid="NULL";
      }

      $DB_site->query("INSERT INTO forum (forumid,title,description,active,displayorder,replycount,lastpost,lastposter,threadcount,categoryid,allowposting,daysprune,moderatenew,allowbbcode,allowimages,allowhtml,allowsmilies) VALUES ($forumid,'".addslashes($title)."','".addslashes($description)."',$canview,$displayorder,0,0,'',0,$categoryid,1,15,0,$bbcodeon,$bbimgon,$htmlon,1)");
      if ($forumid=="NULL") {
        $forumid=$DB_site->insert_id();
      }

      $varname="Forum$forumid"."Moderator";
      $forummods=explode("||^||",$$varname);
      while (list($key,$val)=each($forummods)) {
        if ($val!="") {

          if ($user=$DB_site->query_first("SELECT userid,usergroupid,customtitle,username,email FROM user WHERE username='".addslashes($val)."'")) {

            echo "<p>Adding $val as a moderator</p>";
            flush();

            $usergroup=$DB_site->query_first("SELECT title,usergroupid,canview,cansearch,canemail,canpostnew,canreply,canadminedit,canedit,candelete,canopenclose,canmove,cancontrolpanel FROM usergroup WHERE usergroupid=$user[usergroupid]");

            // check if he is already in an autogenerated user group
            if (substr($usergroup[title],0,39)!="!Auto-generated moderator Please leave!") {
              // if he is not in auto generated group, check to see if he is only one in his group
              $checkcount=$DB_site->query_first("SELECT COUNT(userid) AS users FROM user WHERE usergroupid=$usergroup[usergroupid]");
              if ($checkcount[users]!=1) {
                // he is not on his own - create new user group based on his current one plus moderator status
                $DB_site->query("INSERT INTO usergroup (usergroupid,title,usertitle,canview,cansearch,canemail,canpostnew,canreply,canadminedit,canedit,candelete,canopenclose,canmove,cancontrolpanel) VALUES (NULL,'!Auto-generated moderator Please leave! ".addslashes($user[username])."','Moderator',$usergroup[canview],$usergroup[cansearch],$usergroup[canemail],$usergroup[canpostnew],$usergroup[canreply],$usergroup[canadminedit],$usergroup[canedit],$usergroup[candelete],$usergroup[canopenclose],$usergroup[canmove],$usergroup[cancontrolpanel])");
                $user[usergroupid]=$DB_site->insert_id();
                $usergroup[usergroupid]=$user[usergroupid];
                $DB_site->query("UPDATE user SET usergroupid=$usergroup[usergroupid]".iif($user[customtitle]==1,",usertitle='Moderator'","")." WHERE userid=$user[userid]");
              }
            }

            $DB_site->query("INSERT INTO forumpermission (forumpermissionid,usergroupid,forumid,canview,cansearch,canemail,canpostnew,canreply,canadminedit,canedit,candelete,canopenclose,canmove) VALUES (NULL,$user[usergroupid],$forumid,$usergroup[canview],$usergroup[cansearch],$usergroup[canemail],$usergroup[canpostnew],$usergroup[canreply],1,$usergroup[canedit],$usergroup[candelete],$usergroup[canopenclose],$usergroup[canmove])");
            //done!

            // set up email bits
            if ($newpostemail==1) {
              $DB_site->query("UPDATE forum SET newpostemail=CONCAT(newpostemail,' $user[email]'),newthreademail=CONCAT(newthreademail,' $user[email]') WHERE forumid=$forumid");
            }
          } // get userid
        } // if $val!=""
      } // each moderator
    } //if $val!=""
  } //each forum

  $ubbsettingsdir=urlencode($ubbsettingsdir);
  $ubbnoncgidir=urlencode($ubbnoncgidir);

  echo "<p><b>Forums added correctly. Please import posts now.</p>";
  echo "<p>Click <a href=\"import.php?step=5&ubbsettingsdir=$ubbsettingsdir&ubbnoncgidir=$ubbnoncgidir&ubbnoncgiurl=$ubbnoncgiurl\">here</a> to import posts</b></p>";
}

if ($step==5) {

  echo "<p>Mass import: this will move ALL posts from Forum1 in the UBB into Forum 1 in vBulletin, Forum2 into Forum 2, etc - it could take a while.</p>";

  echo doformheader("import","");
  echo makehiddencode("step","6");
  echo makehiddencode("ubbnoncgidir",$ubbnoncgidir);
  echo makehiddencode("ubbnoncgiurl",$ubbnoncgiurl);
  echo makehiddencode("ubbsettingsdir",$ubbsettingsdir);
  echo makehiddencode("massmove","1");
  echo makehiddencode("forumid","1");
  echo makehiddencode("destforumid","1");
  echo makehiddencode("page","1");
  echo "<table border=0>";
  echo makeinputcode("Cycle rate","numberpost","200");
  echo doformfooter("Do Mass import");

  echo "<hr>";

  echo "<P>Current forums in the UBB</p>";

  echo "<ul>";

  $forums=file(urldecode($ubbsettingsdir)."/forums.cgi");

  while (list($key,$val)=each($forums)) {

    if ($val!="") {
      $parts=explode("|",$val);
      echo "<li>Forum number: $parts[8], name: $parts[1]</li>\n";
    }
  }

  echo doformheader("import","next");
  echo makehiddencode("step","6");
  echo makehiddencode("ubbnoncgidir",$ubbnoncgidir);
  echo makehiddencode("ubbnoncgiurl",$ubbnoncgiurl);
  echo makehiddencode("ubbsettingsdir",$ubbsettingsdir);
  echo "<table border=0>";

  echo makeinputcode("Enter forum number to import:","forumid");
  echo makechoosercode("Select target forum:","destforumid","forum");
  echo makeyesnocode("Empty forum of threads before importing? (Recommened: yes)","emptyforum",1);
  echo makeinputcode("Number of threads to import at once","numberpost","200");
  echo doformfooter();

  echo "<p>Only click the button once and then wait. It can take a long time to import threads - it should do a rate of at least 200 threads per minute.</p>";

}

if ($step==6) {

  if ($forumid=="") {
    echo "<p>Make sure that you select a forum number</p>";
    exit;
  }

  $forums=file(urldecode($ubbsettingsdir)."/forums.cgi");

  while (list($key,$val)=each($forums)) {

    if ($val!="") {
      $parts=explode("|",$val);
      if ($parts[8]==$forumid and $parts[6]=="private") {
        $dir=trim($parts[7]);
      }
    }
  }

  if ($emptyforum==1) {
    echo "<p>Deleting threads...";
    // empty forum
    $threads=$DB_site->query("SELECT threadid FROM thread WHERE forumid=$destforumid");

    while ($thread=$DB_site->fetch_array($threads)) {
      $DB_site->query("DELETE FROM post WHERE threadid=$thread[threadid]");
    }

    $DB_site->query("DELETE FROM thread WHERE forumid=$destforumid");

    echo "successful</p>";
  }

  echo "<script language=\"javascript\">window.location=\"import.php?step=7&massmove=$massmove&dir=$dir&ubbnoncgidir=$ubbnoncgidir&ubbnoncgiurl=$ubbnoncgiurl&ubbsettingsdir=$ubbsettingsdir&forumid=$forumid&destforumid=$destforumid&numberpost=$numberpost&page=1\";</script>";
  echo "<p><a href=\"import.php?step=7&massmove=$massmove&dir=$dir&ubbnoncgidir=$ubbnoncgidir&ubbnoncgiurl=$ubbnoncgiurl&ubbsettingsdir=$ubbsettingsdir&forumid=$forumid&destforumid=$destforumid&emptyforum=$emptyforum&numberpost=$numberpost&page=1\">Click here to start importing</a></p>";

}


if ($step==7) {

  echo "<p>If your browser does not support Javascript, you will have to click on the link at the end of this page manually to take you on to the next page.</p>";

  echo "<p>Doing forum $forumid. This could take a while - it can do at least 200 threads per minute on my test server</p><ul>";
  echo "<p>Doing threads threads ".(($page-1)*$numberpost)." to ".($page*$numberpost)."</p>";

  flush();

  if ($dir!="") {
    $dirinsert="/private-$dir";
  }

  $ubbnoncgidir=urldecode($ubbnoncgidir);
  $ubbnoncgiurl=urldecode($ubbnoncgiurl);

  if (file_exists("$ubbnoncgidir/Forum$forumid$dirinsert/forum$forumid.threads")==1) {
    $allthreads=file("$ubbnoncgidir/Forum$forumid$dirinsert/forum$forumid.threads");
  } else {
    if (file_exists("$ubbnoncgidir/Forum$forumid/forum$forumid.threads")==1 and $dirinsert!="") {
      $allthreads=file("$ubbnoncgidir/Forum$forumid/forum$forumid.threads");
    } else {
      if ($massmove==1) {
        echo "<p><b>All forums imported correctly!</p>";
        echo "<p>Click <a href=\"import.php?step=8&ubbsettingsdir=$ubbsettingsdir&ubbnoncgidir=$ubbnoncgidir&ubbnoncgiurl=$ubbnoncgiurl\">here</a> to import archives.</b></p>";
      } else {
        echo "<p>Cannot find forum's thread information file. Cannot continue.</p>";
      }
      exit;
    }
  }

  $doneimport=0;

  $threadcount=0;
  while (list($key,$val)=each($allthreads)) {
    $threadcount++;

    if (trim($val)!="" and $threadcount>=(($page-1)*$numberpost) and $threadcount<($page*$numberpost)) {
      $doneimport=1;

      $parts="";
      $parts=explode("|^|",$val);

      $threadstring="$parts[1]";
      $threadtitle=$parts[2];
      $replycount=intval($parts[3]);
      $postusername=$parts[4];
      $threaddate=$parts[5];
      $open=iif(trim($parts[6])=="X",0,1);
      $iconid=intval($parts[7]);

      if (trim($threadtitle)!="" and trim($replycount)!="" and file_exists("$ubbnoncgidir/Forum$forumid$dirinsert/$threadstring.cgi")==1) {
        echo "<li>Doing thread $threadtitle";
        flush();

        $DB_site->query("INSERT INTO thread (threadid,title,lastpost,forumid,open,replycount,postusername,lastposter,dateline,iconid,views,notes,visible) VALUES (NULL,'".addslashes($threadtitle)."',$threaddate,$destforumid,$open,$replycount,'".addslashes($postusername)."','',$threaddate,$iconid,0,'',1)");

        $threadid=$DB_site->insert_id();

        $allposts="";
        $allposts=file("$ubbnoncgidir/Forum$forumid$dirinsert/$threadstring.cgi");

        // get first intro line
        list($postkey,$postval)=each($allposts);
        $postparts=explode("||",$postval);

        if (trim($postparts[1])=="N") {
          $threadnotify=1;
        } else {
          $threadnotify=0;
        }

        $firstpost=1;
        $counter=0;

        $query="";

        while (list($postkey,$postval)=each($allposts)) {
          $counter++;

          if ($postval!="") {
            $postparts="";
            $postparts=explode("||",$postval);

            $postusername=$postparts[2];
            if ($postparts[8]=="reg") {
              if ($getuserid=$DB_site->query_first("SELECT userid FROM user WHERE username='".addslashes($postusername)."'")) {
                $userid=$getuserid[userid];
                $postusername="";
              } else {
                $userid=0;
              }
            } else {
              $userid=0;
            }

            $dateline="";

            $ipaddress=$postparts[7];
            $postdate=$postparts[3];
            if ( ereg( "([0-9]{1,2})-([0-9]{1,2})-([0-9]{2,4})", $postdate, $dateregs ) ) {
              $year=$dateregs[3];
              $month=$dateregs[1];
              $day=$dateregs[2];
            }

            $posttime=$postparts[4];
            if ( ereg( "([0-9]{1,2}):([0-9]{1,2}) ([A-Z]{2})", $posttime, $timeregs ) ) {
              if ($timeregs[1]==12 and $timeregs[3]=="AM") {
                $timeregs[1]=0;
              }
              if ($timeregs[1]!=12 and $timeregs[3]=="PM") {
                $timeregs[1]+=12;
                if ($timeregs[1]==24) {
                  $timeregs[1]=0;
//                  $day++; THIS LINE SHOULD BE USED, BUT IT WAS CAUSING INCORRECT DATES, SO I REMOVED IT
                }
              }
              $hour=$timeregs[1];
              $minute=$timeregs[2];
            }
            $dateline=mktime($hour,$minute,0,$month,$day,$year)-($timeoffset)*3600;

            if ($dateline=="") {
              $dateline=time();
            }

            $postmessage=html2bb($postparts[6]);

            $iconid=intval($postparts[9]);
            if ($firstpost==1) {
              $firstpost=0;
            } else {
              $threadnotify=0;
            }

            if ($query=="") {
              $query="INSERT INTO post (postid,threadid,username,userid,title,dateline,pagetext,allowsmilie,email,signature,ipaddress,iconid,visible) VALUES (NULL,$threadid,'".addslashes($postusername)."',$userid,'',$dateline,'".addslashes($postmessage)."',1,$threadnotify,0,'".addslashes($ipaddress)."',$iconid,1)";
            } else {
              $query.=",(NULL,$threadid,'".addslashes($postusername)."',$userid,'',$dateline,'".addslashes($postmessage)."',1,$threadnotify,0,'".addslashes($ipaddress)."',$iconid,1)";
            }
          } // if postval!=""
        }  // while each post

        $DB_site->query($query);

        $thread=$DB_site->query_first("SELECT MIN(post.postid) AS minpost,MAX(post.postid) AS maxpost,thread.threadid,MAX(post.dateline) AS dateline,(COUNT(post.postid)-1) AS posts FROM post,thread WHERE thread.threadid=post.threadid AND thread.threadid=$threadid GROUP BY threadid");

        $numberposts=$thread[posts];
        $lastpost=$thread[dateline];
        $firstusername=$DB_site->query_first("SELECT username,userid FROM post WHERE postid=$thread[minpost]");
        if ($firstusername[userid]==0) {
          $firstusername=$firstusername[username];
        } else {
          $users=$DB_site->query_first("SELECT username FROM user WHERE userid=$firstusername[userid]");
          $firstusername=$users[username];
        }

        $lastusername=$DB_site->query_first("SELECT username,userid FROM post WHERE postid=$thread[maxpost]");
        if ($lastusername[userid]==0) {
          $lastusername=$lastusername[username];
        } else {
          $users=$DB_site->query_first("SELECT username FROM user WHERE userid=$lastusername[userid]");
          $lastusername=$users[username];
        }

        $DB_site->query("UPDATE thread SET lastpost=$lastpost,replycount=$numberposts,postusername='".addslashes($firstusername)."',lastposter='".addslashes($lastusername)."' WHERE threadid=$threadid");
        indexthread($threadid);

      }  // if $title!=""
    } // if val!=""
  }  // while each thread
  echo "</ul>";


  $ubbnoncgidir=urlencode($ubbnoncgidir);
  $ubbnoncgiurl=urlencode($ubbnoncgiurl);

  if ($doneimport==1) {
    echo "<p>Posts imported correctly. Starting the next batch...</p>";
    echo "<script language=\"javascript\">window.location=\"import.php?step=7&massmove=$massmove&dir=$dir&ubbnoncgidir=$ubbnoncgidir&ubbnoncgiurl=$ubbnoncgiurl&ubbsettingsdir=$ubbsettingsdir&forumid=$forumid&destforumid=$destforumid&numberpost=$numberpost&page=".($page+1)."\";</script>";
    echo "<p><a href=\"import.php?step=7&massmove=$massmove&dir=$dir&ubbnoncgidir=$ubbnoncgidir&ubbnoncgiurl=$ubbnoncgiurl&ubbsettingsdir=$ubbsettingsdir&forumid=$forumid&destforumid=$destforumid&numberpost=$numberpost&page=".($page+1)."\">Click here is your browser does not support javascript or does not take you to the next page</a></p>";
  } else {

    if ($numpost=$DB_site->query_first("SELECT COUNT(postid) AS posts FROM post,thread WHERE thread.threadid=post.threadid AND thread.forumid=$destforumid")) {
      $numberposts=$numpost[posts];
    } else {
      $numberposts=0;
    }

    if ($numpost=$DB_site->query_first("SELECT COUNT(threadid) AS posts FROM thread WHERE thread.forumid=$destforumid")) {
      $numberthreads=$numpost[posts];
    } else {
      $numberthreads=0;
    }

    if ($lastposts=$DB_site->query_first("SELECT lastpost,lastposter FROM thread WHERE forumid=$destforumid ORDER BY lastpost DESC LIMIT 1")) {
      $lastpost=$lastposts[lastpost];
      $lastposter=$lastposts[lastposter];
    } else {
      $lastpost=0;
      $lastposter="";
    }

    $DB_site->query("UPDATE forum SET replycount=$numberposts,threadcount=$numberthreads,lastpost=$lastpost,lastposter='".addslashes($lastposter)."' WHERE forumid=$destforumid");

    if ($massmove==1) {
      $forumid++;

      $maxforum=$DB_site->query_first("SELECT MAX(forumid) AS forumid FROM forum");
      if ($forumid>$maxforum[forumid]) {
        echo "<p><b>All forums imported correctly!</p>";
        echo "<p>Click <a href=\"import.php?step=8&ubbsettingsdir=$ubbsettingsdir&ubbnoncgidir=$ubbnoncgidir&ubbnoncgiurl=$ubbnoncgiurl\">here</a> to import archives.</b></p>";
      } else {
        echo "<script language=\"javascript\">window.location=\"import.php?step=6&massmove=1&ubbnoncgidir=$ubbnoncgidir&ubbnoncgiurl=$ubbnoncgiurl&ubbsettingsdir=$ubbsettingsdir&forumid=$forumid&destforumid=$forumid&numberpost=$numberpost&page=1\";</script>";
        echo "<p><a href=\"import.php?step=6&massmove=1&ubbnoncgidir=$ubbnoncgidir&ubbnoncgiurl=$ubbnoncgiurl&ubbsettingsdir=$ubbsettingsdir&forumid=$forumid&destforumid=$forumid&numberpost=$numberpost&page=1\">Click here is your browser does not support javascript or does not take you to the next page</a></p>";
      }
    } else {
      echo "<p><b>All Threads imported successfully. Click <a href=\"import.php?step=5&dir=$dir&ubbsettingsdir=$ubbsettingsdir&ubbnoncgidir=$ubbnoncgidir&ubbnoncgiurl=$ubbnoncgiurl\">here</a> to continue with another forum.</p>";

      echo "<p>Click <a href=\"import.php?step=8&ubbsettingsdir=$ubbsettingsdir&ubbnoncgidir=$ubbnoncgidir&ubbnoncgiurl=$ubbnoncgiurl\">here</a> to import archives.</b></p>";
    }
  }
}

if ($step==8){
  if ($goforit=="") {
    $DB_site->query("INSERT INTO category (categoryid,title,displayorder) VALUES (NULL,'Archives',10)");
    $categoryid=$DB_site->insert_id();

    echo "<p>Click <a href=\"import.php?step=8&archivenum=1&categoryid=$categoryid&goforit=go&ubbsettingsdir=$ubbsettingsdir&ubbnoncgidir=$ubbnoncgidir&ubbnoncgiurl=$ubbnoncgiurl\">here</a> to go ahead and import archives.</p>";
    exit;
  }

  $ubbnoncgidir=urldecode($ubbnoncgidir);
  $ubbnoncgiurl=urldecode($ubbnoncgiurl);

  if (file_exists("$ubbnoncgidir/Archives/archives.pl")!=1) {
    echo "<p>No archives found. Not continuing</p>";
    exit;
  }

  $archives=file("$ubbnoncgidir/Archives/archives.pl");

  echo "<p>Importing archive $archivenum</p>";
  flush();

  $counter=0;
  while (list($key,$archiveinfo)=each($archives)) {
    $counter++;
    if ($archiveinfo!="" and $counter==$archivenum) {

      $archiveparts=explode("|#|",$archiveinfo);

      $forumtitle=$archiveparts[1];
      $description=$archiveparts[2];

      echo "<p>Importing archive $forumtitle</p>";
      flush();

      $DB_site->query("INSERT INTO forum (forumid,title,description,active,displayorder,replycount,lastpost,lastposter,threadcount,categoryid,allowposting,daysprune,moderatenew,allowbbcode,allowimages,allowhtml,allowsmilies) VALUES (NULL,'".addslashes($forumtitle)."','".addslashes($description)."',1,$archivenum,0,".time().",'',0,$categoryid,0,1000,0,1,1,1,1)");
      $forumid=$DB_site->insert_id();

      if (file_exists("$ubbnoncgidir/Archives/Archive-$archiveparts[0]/archives.thread")==1) {
        $allthreads=file("$ubbnoncgidir/Archives/Archive-$archiveparts[0]/archives.thread");
      } else {
        $allthreads[0]="";
      }

      $doneimport=0;

      while (list($key,$val)=each($allthreads)) {

        if (trim($val)!="") {
          $doneimport=1;

          $parts="";
          $parts=explode("|#|",$val);

          $threadtitle=$parts[0];
          $postusername=$parts[2];
          $dateparts=explode("-",$parts[1]);
          $threaddate=trim($dateparts[0]);

          if (trim($threadtitle)!="" and file_exists("$ubbnoncgidir/Archives/Archive-$archiveparts[0]/$parts[1].cgi")==1) {
            echo "<li>Doing thread $threadtitle";
            flush();

            $DB_site->query("INSERT INTO thread (threadid,title,lastpost,forumid,open,replycount,postusername,lastposter,dateline,iconid,views,notes,visible) VALUES (NULL,'".addslashes($threadtitle)."',$threaddate,$forumid,0,0,'".addslashes($postusername)."','',$threaddate,0,0,'',1)");

            $threadid=$DB_site->insert_id();

            $allposts="";
            $allposts=file("$ubbnoncgidir/Archives/Archive-$archiveparts[0]/$parts[1].cgi");

            // get first intro line
            list($postkey,$postval)=each($allposts);
            $postparts=explode("||",$postval);

            if (trim($postparts[1])=="N") {
              $threadnotify=1;
            } else {
              $threadnotify=0;
            }

            $firstpost=1;
            $counter=0;
            while (list($postkey,$postval)=each($allposts)) {
              $counter++;

              if ($postval!="") {
                $postparts="";
                $postparts=explode("||",$postval);

                $postusername=$postparts[2];
                if ($postparts[8]=="reg") {
                  if ($getuserid=$DB_site->query_first("SELECT userid FROM user WHERE username='".addslashes($postusername)."'")) {
                    $userid=$getuserid[userid];
                    $postusername="";
                  } else {
                    $userid=0;
                  }
                } else {
                  $userid=0;
                }

                $dateline="";

                $ipaddress=$postparts[7];
                $postdate=$postparts[3];
                if ( ereg( "([0-9]{1,2})-([0-9]{1,2})-([0-9]{2,4})", $postdate, $dateregs ) ) {
                  $year=$dateregs[3];
                  $month=$dateregs[1];
                  $day=$dateregs[2];
                }

                $posttime=$postparts[4];
                if ( ereg( "([0-9]{1,2}):([0-9]{1,2}) ([A-Z]{2})", $posttime, $timeregs ) ) {
                  if ($timeregs[1]==12 and $timeregs[3]=="AM") {
                    $timeregs[1]=0;
                  }
                  if ($timeregs[1]!=12 and $timeregs[3]=="PM") {
                    $timeregs[1]+=12;
                    if ($timeregs[1]==24) {
                      $timeregs[1]=0;
                      //$day++;
                    }
                  }
                  $hour=$timeregs[1];
                  $minute=$timeregs[2];
                }
                $dateline=mktime($hour,$minute,0,$month,$day,$year)-($timeoffset)*3600;

                if ($dateline=="") {
                  $dateline=time();
                }

                $postmessage=html2bb($postparts[6]);

                $iconid=$postparts[9];
                if (trim($iconid)=="") {
                  $iconid=0;
                } else {
                  $iconid=intval($iconid);
                }
                if ($firstpost==1) {
                  $firstpost=0;
                } else {
                  $threadnotify=0;
                }
                $DB_site->query("INSERT INTO post (postid,threadid,username,userid,title,dateline,pagetext,allowsmilie,email,signature,ipaddress,iconid,visible) VALUES (NULL,$threadid,'".addslashes($postusername)."',$userid,'',$dateline,'".addslashes($postmessage)."',1,$threadnotify,0,'".addslashes($ipaddress)."',$iconid,1)");
              } // if postval!=""
            }  // while each post

            $thread=$DB_site->query_first("SELECT MIN(post.postid) AS minpost,MAX(post.postid) AS maxpost,thread.threadid,MAX(post.dateline) AS dateline,(COUNT(post.postid)-1) AS posts FROM post,thread WHERE thread.threadid=post.threadid AND thread.threadid=$threadid GROUP BY threadid");

            $numberposts=$thread[posts];
            $lastpost=$thread[dateline];
            $firstusername=$DB_site->query_first("SELECT username,userid FROM post WHERE postid=$thread[minpost]");
            if ($firstusername[userid]==0) {
              $firstusername=$firstusername[username];
            } else {
              $users=$DB_site->query_first("SELECT username FROM user WHERE userid=$firstusername[userid]");
              $firstusername=$users[username];
            }

            $lastusername=$DB_site->query_first("SELECT username,userid FROM post WHERE postid=$thread[maxpost]");
            if ($lastusername[userid]==0) {
              $lastusername=$lastusername[username];
            } else {
              $users=$DB_site->query_first("SELECT username FROM user WHERE userid=$lastusername[userid]");
              $lastusername=$users[username];
            }

            $DB_site->query("UPDATE thread SET lastpost=$lastpost,replycount=$numberposts,postusername='".addslashes($firstusername)."',lastposter='".addslashes($lastusername)."' WHERE threadid=$threadid");
            indexthread($threadid);

          }  // if $title!=""
        } // if val!=""
      }  // while each thread
      echo "</ul>";

    } // if doing this archive
  }  // while each archive

  $ubbnoncgidir=urlencode($ubbnoncgidir);
  $ubbnoncgiurl=urlencode($ubbnoncgiurl);

  if ($doneimport==1) {
    $forum=$DB_site->query_first("SELECT forumid FROM forum WHERE forumid=$forumid");

    if ($numpost=$DB_site->query_first("SELECT COUNT(postid) AS posts FROM post,thread WHERE thread.threadid=post.threadid AND thread.forumid=$forumid")) {
      $numberposts=$numpost[posts];
    } else {
      $numberposts=0;
    }

    if ($numpost=$DB_site->query_first("SELECT COUNT(threadid) AS posts FROM thread WHERE thread.forumid=$forumid")) {
      $numberthreads=$numpost[posts];
    } else {
      $numberthreads=0;
    }

    if ($lastposts=$DB_site->query_first("SELECT lastpost,lastposter FROM thread WHERE forumid=$forumid ORDER BY lastpost DESC LIMIT 1")) {
      $lastpost=$lastposts[lastpost];
      $lastposter=$lastposts[lastposter];
    } else {
      $lastpost=0;
      $lastposter="";
    }

    $DB_site->query("UPDATE forum SET replycount=$numberposts,threadcount=$numberthreads,lastpost=$lastpost,lastposter='".addslashes($lastposter)."' WHERE forumid=$forumid");

    echo "<p>Archive imported correctly. Starting the next one...</p>";
    echo "<script language=\"javascript\">window.location=\"import.php?step=8&archivenum=".($archivenum+1)."&categoryid=$categoryid&goforit=go&ubbsettingsdir=$ubbsettingsdir&ubbnoncgidir=$ubbnoncgidir&ubbnoncgiurl=$ubbnoncgiurl\";</script>";
    echo "<p><a href=\"import.php?step=8&archivenum=".($archivenum+1)."&categoryid=$categoryid&goforit=go&ubbsettingsdir=$ubbsettingsdir&ubbnoncgidir=$ubbnoncgidir&ubbnoncgiurl=$ubbnoncgiurl\">Click here is your browser does not support javascript or does not take you to the next page</a></p>";
  } else {

    echo "<p><b>Archives imported successfully. UBB import is complete.</b></p>";

  }

}  // step 8
?>
</body></html>