<?php

require("global.php");

if (isset($action)==0 or $action=="") {
  $action="newthread";
}

checkipban();

// ############################### start post thread ###############################
if ($action=="postthread") {

  // check for subject and message
  if (trim($subject)=="" or trim($message)=="") {
    echo standarderror($bbtitle,gettemplate("error_nosubject",0));
    exit;
  }

  $forumid=verifyid("forum",$forumid);

  //check valid username and password and get user id
  if ($password=="" and $username!="") {
    if ($checkuser=$DB_site->query_first("SELECT username FROM user WHERE username='".addslashes($username)."'")) {
      $userid=verifyusername($username,$password);
      $username=$checkuser[username];
    } else {
      $userid=0;
      $signature="";
      $email="";
    }
  } else {
    $userid=verifyusername($username,$password);

    $userinfo=$DB_site->query_first("SELECT canpost,lastpost,usertitle,customtitle,usergroupid,posts FROM user WHERE userid=$userid");
    if ($userinfo[canpost]==0) {
      echo standarderror($bbtitle,gettemplate("error_usernopost",0));
      exit;
    }

  }

  // decode check boxes
  $parseurl=iif($parseurl=="yes",1,0);
  $email=iif($email=="yes",1,0);
  $allowsmilie=iif($disablesmilies=="yes",0,1);
  $signature=iif($signature=="yes",1,0);
  $preview=iif($preview!="",1,0);

  $foruminfo=$DB_site->query_first("SELECT active,allowposting,title,moderatenew FROM forum WHERE forumid=$forumid");
  $forumtitle=$foruminfo[title];
  if ($foruminfo[active]==0) {
    echo standarderror($bbtitle,gettemplate("error_forumclosed",0));
    exit;
  }
  if ($foruminfo[allowposting]==0) {
    echo standarderror($bbtitle,gettemplate("error_forumnoreply",0));
    exit;
  }
  $visible=iif($foruminfo[moderatenew]==1,0,1);

  if ($parseurl==1) {
    $message=parseurl($message);
  }

  if ($preview==1) {
    $previewpost=1;
    $previewmessage=bbcodeparse($message,$forumid,$allowsmilie);

    if ($signature==1) {
      $getsig=$DB_site->query_first("SELECT signature FROM user WHERE userid=$userid");
      $previewmessage.=bbcodeparse("\n__________________\n$getsig[signature]",0,$allowsmilies);
    }

    eval("\$postpreview=\"".gettemplate("postpreview")."\";");

    $parseurlchecked=iif($parseurl==1,"checked","");
    $emailchecked=iif($email==1,"checked","");
    $disablesmilieschecked=iif($allowsmilie==0,"checked","");
    $signaturechecked=iif($signature==1,"checked","");
    $previewchecked=0;

//    $posticons=chooseicons($iconid);

    $bbusername=$username;
    $bbpassword=$password;

    $action="newthread";
  } else {

    if ($enablefloodcheck==1) {
      if ($userid!=0 and time()-$userinfo[lastpost]<=$floodchecktime) {
        eval("echo standarderror(\$bbtitle,\"".gettemplate("error_floodcheck")."\");");
        exit;
      }
    }

    if (isset($iconid)==0 or $iconid=="") {
      $iconid=0;
    }

    $permissions=getpermissions($bbuserid,$bbusergroupid,$forumid);
    if ($permissions[canview]!=1 or $permissions[canpostnew]!=1) {
      eval("echo standarderror(\$bbtitle,\"".gettemplate("error_nopermission")."\");");
      exit;
    }

    if ($logip==1 or $logip==2) {
      $ipaddress=getenv("REMOTE_ADDR");
    } else {
      $ipaddress="";
    }

    // check max images
    if ($maximages!=0) {
      $parsedmessage=bbcodeparse($message,$forumid,$allowsmilie);
      if (countchar($parsedmessage,"<img")>$maximages) {
        eval("echo standarderror(\$bbtitle,\"".gettemplate("error_toomanyimages")."\");");
        exit;
      }
    }

    $subject=censortext($subject);
    $message=censortext($message);

    // see if there has been a post identical to this in the last 5 mins.  If so, update that one, as user has probably done a double post
    $datecut=time()-300;
    if ($prevpost=$DB_site->query_first("SELECT threadid,visible FROM thread WHERE forumid=$forumid AND postusername='".addslashes($username)."' AND title='".addslashes($subject)."' AND dateline>$datecut AND replycount=0")) {
      $threadid=$prevpost[threadid];
      $iconid = intval($iconid);
      $DB_site->query("UPDATE thread SET title='".addslashes($subject)."',iconid=$iconid WHERE threadid=$threadid");
      $posts=$DB_site->query_first("SELECT MIN(post.postid) AS minpost FROM post,thread WHERE thread.threadid=post.threadid AND thread.threadid=$threadid GROUP BY thread.threadid");
      $DB_site->query("UPDATE post SET pagetext='".addslashes($message)."',allowsmilie=$allowsmilie,email=$email,signature=$signature,iconid=$iconid WHERE postid=$posts[minpost]");

      // redirect
      if ($prevpost[visible]==1) {
        $goto="showthread.php?threadid=$threadid";
      } else {
        $goto="forumdisplay.php?forumid=$forumid";
      }
      eval("echo standardredirect(\$bbtitle,\"".gettemplate("redirect_postthanks")."\",\"$goto\");");

    } else {
      //create new thread
      $DB_site->query("INSERT INTO thread (threadid,title,lastpost,forumid,open,replycount,postusername,lastposter,dateline,iconid,visible) VALUES (NULL,'".addslashes($subject)."',".time().",$forumid,1,0,'".addslashes($username)."','".addslashes($username)."',".time().",$iconid,$visible)");
      $threadid=$DB_site->insert_id();

      if ($userid==0) {
        $postusername=$username;
      } else {
        $postusername="";
      }
      // create first post
      $DB_site->query("INSERT INTO post (postid,threadid,title,username,userid,dateline,pagetext,allowsmilie,email,signature,ipaddress,iconid,visible) VALUES (NULL,$threadid,'','".addslashes($postusername)."',$userid,".time().",'".addslashes($message)."',$allowsmilie,$email,$signature,'$ipaddress',$iconid,1)");

      indexthread($threadid);

//      $DB_site->query("UPDATE user SET lastpost=".time()." WHERE userid=$userid");

      // update forum stuff
      $DB_site->query("UPDATE forum SET replycount=replycount+1,threadcount=threadcount+1,lastpost=".time().",lastposter='".addslashes($username)."' WHERE forumid=$forumid");

      // update user stuff
      if ($userid!=0) {
        $usergroup=$DB_site->query_first("SELECT usertitle FROM usergroup WHERE usergroupid=$userinfo[usergroupid]");
        if ($usergroup[usertitle]=="") {
          $gettitle=$DB_site->query_first("SELECT title FROM usertitle WHERE minposts<=$userinfo[posts]+1 ORDER BY minposts DESC LIMIT 1");
          $usertitle=$gettitle[title];
        } else {
          $usertitle=$usergroup[usertitle];
        }

        if ($userinfo[customtitle]==0) {
          $dotitle="usertitle='".addslashes($usertitle)."',";
        }

        $DB_site->query("UPDATE user SET posts=posts+1,$dotitle"."lastpost=".time()." WHERE userid=$userid");
      }

      // send email to moderators
      if ($enableemail==1) {
        $moderators=$DB_site->query_first("SELECT CONCAT(newthreademail,' ',newpostemail) AS newthreademail FROM forum WHERE forumid=$forumid");
        if ($moderators[newthreademail]!="") {
          $mods=explode(" ",$moderators[newthreademail]);
          while (list($key,$val)=each($mods)) {

            if (trim($val)!="") {
              $subject=$threadtitle;
              $toemail=$val;

              eval("\$emailmsg = \"".gettemplate("moderatoremail")."\";");
              mail($toemail,"Notification: New BB Thread",$emailmsg,"From: \"$bbtitle Post Manager\" <$webmasteremail>");
            }
          }
        }
      }

      // redirect
      if ($visible==1) {
        $goto="showthread.php?threadid=$threadid";
      } else {
        $goto="forumdisplay.php?forumid=$forumid";
      }
      eval("echo standardredirect(\$bbtitle,\"".gettemplate("redirect_postthanks")."\",\"$goto\");");
    }
  }
}

// ############################### start new thread ###############################
if ($action=="newthread") {
  $forumid = verifyid("forum",$forumid);

  $foruminfo=$DB_site->query_first("SELECT title,description,active,categoryid,allowposting,titleimage,newthreadtemplate,headertemplate,useadvheader,footertemplate,useadvfooter,rulestemplate,allowbbcode,allowimages,allowhtml,allowsmilies FROM forum WHERE forumid=$forumid");
  $forumtitle=htmlspecialchars($foruminfo[title]);
  if ($foruminfo[active]==0) {
    echo standarderror($bbtitle,gettemplate("error_forumclosed",0));
    exit;
  }
  if ($foruminfo[allowposting]==0) {
    echo standarderror($bbtitle,gettemplate("error_forumnoreply",0));
    exit;
  }
  if ($foruminfo[titleimage]!="") {
    $titleimage=$foruminfo[titleimage];
  }
  if ($foruminfo[newthreadtemplate]!="") {
    $usetemplate=$foruminfo[newthreadtemplate];
  } else {
    $usetemplate="newthread";
  }

  $bbcodeon=iif($foruminfo[allowbbcode]==1,$ontext,$offtext);
  $imgcodeon=iif($foruminfo[allowimages]==1,$ontext,$offtext);
  $htmlcodeon=iif($foruminfo[allowhtml]==1,$ontext,$offtext);
  $smilieson=iif($foruminfo[allowsmilies]==1,$ontext,$offtext);
  if ($foruminfo[rulestemplate]!="") {
    eval("\$forumrules = \"".gettemplate("$foruminfo[rulestemplate]")."\";");
  } else {
    eval("\$forumrules = \"".gettemplate("forumrules")."\";");
  }

  $getcategory=$DB_site->query_first("SELECT title,categoryid FROM category WHERE categoryid=$foruminfo[categoryid]");
  $categorytitle=$getcategory[title];
  $categoryid=$getcategory[categoryid];

  if ($showicons==1) {
    $posticons=chooseicons($iconid);
  }  else {
    $posticons="";
  }

  if (isset($parseurl)==0) {
    $parseurlchecked="CHECKED";
  }

  // get cookies if set
  $username=$bbusername;
  $password=$bbpassword;

  $permissions=getpermissions($bbuserid,$bbusergroupid,$forumid);
  if ($permissions[canview]!=1 or $permissions[canpostnew]!=1) {
    eval("echo standarderror(\$bbtitle,\"".gettemplate("error_nopermission")."\");");
    exit;
  }

  if ($bbuserid!=0 and $previewpost!=1) {
    $userinfo=$DB_site->query_first("SELECT signature,emailnotification FROM user WHERE userid=$bbuserid");
    if ($userinfo[signature]!="") {
      $signaturechecked="CHECKED";
    }
    if ($userinfo[emailnotification]!=0) {
      $emailchecked="checked";
    }
  }

  // parse header ##################
  if ($foruminfo[headertemplate]!="") {
    if ($foruminfo[useadvheader]==1) {
      eval(gettemplate("$foruminfo[headertemplate]").";");
    } else {
      eval("\$header = \"".gettemplate("$foruminfo[headertemplate]")."\";");
    }
  }
  if ($foruminfo[footertemplate]!="") {
    if ($foruminfo[useadvfooter]==1) {
      eval(gettemplate("$foruminfo[footertemplate]").";");
    } else {
      eval("\$footer = \"".gettemplate("$foruminfo[footertemplate]")."\";");
    }
  }

  if ($foruminfo[allowsmilies]==1) {
    eval("\$disablesmiliesoption = \"".gettemplate("disablesmiliesoption")."\";");
  }
  eval("echo dovars(\"".gettemplate("$usetemplate")."\");");

}

?>